Bug 133040 - Undo/redo includes creating of paragraph/character style
Summary: Undo/redo includes creating of paragraph/character style
Status: RESOLVED WONTFIX
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-05-14 18:15 UTC by Telesto
Modified: 2020-06-05 03:46 UTC (History)
1 user (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Telesto 2020-05-14 18:15:48 UTC
Description:
Undo/redo includes creating of paragraph/character style; doesn't feel right

Steps to Reproduce:
1. Open Writer
2. Open sidebar /styles
3. Click NEW
4. Pick a name 
5. Press OK
6. Drop down the list for undo (notice the style creating)
7. Press Undo -> Style gone
8. Press Redo -> Style is re-inserted but not visible in the list

Actual Results:
The creating of paragraph/character style is included in undo redo

Expected Results:
I don't perceive an style as a 'document' change. So if I press undo in document, after I created a style, it doesn't mean I want to remove the style per se.


Reproducible: Always


User Profile Reset: No



Additional Info:
Version: 7.0.0.0.alpha1+ (x64)
Build ID: f9790da286f2d2fa47f1748f8cfa6172c6622ca3
CPU threads: 4; OS: Windows 6.3 Build 9600; UI render: Skia/Raster; VCL: win; 
Locale: nl-NL (nl_NL); UI: en-US
Calc: CL

also in
3.5.7.2
Comment 1 Telesto 2020-05-14 18:28:54 UTC
Feature..
Comment 2 Telesto 2020-05-15 17:57:27 UTC
@Heiko
Lets reopen this one.. for small UX inquiry; challenging the current situation

I generally separate styles from document changes. Yes, styles are included in the document; and a relevant for formatting. But creating a style has nothing to do with the document itself (as long as not applied). Same thing is true for deleting a non-active style or changing a non-active style. 

In document changes only occur deleting an active style and changing an active style.

Currently everything is included in the document Undo/Redo system. The creation/deletion/changing of an style.. 

However, there are number of 'flaws'
* An active document style is can be delete - after warning. The undo restores the style, but not places where it was used (The warning suggests this already). Point is about undo being somewhat pointless.
* The redo bit buggy: bug 133041
* Inconsistent: Drag child styles to a different parent is not included in undo/redo (and changes the formatting a lot)
* The undo of the creation of a style can be counter productive.. Say I create a style, and want to undo some changes I made before creating the style .. Not possible without losing the style
* Undo/redo of style change is mostly not an option after in documents edits are made
* Undo/redo doesn't make sense if there where multiple style changes and you want to undo an older change.

The only case for undo/redo is the situation where you're fiddling with the style.. and want to check how it looks.. If not as expect, you press CTRL+Z (of course not me, as I didn't expect styles being included in undo/redo at the first place..)

So, in my view it 
(a) would make sense to disable undo/redo in general for styles changes
(b) And if there should be Undo/redo for styles.. in general.. separate it from the 'general' undo/redo. 
(c) if this is not possible restrict undo/redo to changes of (active) styles.. 

For the record: 'applying an style' a style to a paragraph/character is still an in document change. It's about mutations related to the styles as such.

I'm aware this being long time behavior.. so there are probably some workflows relying the current undo/redo.
Comment 3 Heiko Tietze 2020-06-04 12:51:19 UTC
Abandoning the undo feature for style _creation_ means also to not being able to undo unintentionally _deleted_ styles. And _applying_ styles to the document is the main workflow. 
The actual problem is the unexpected deletion (via undo), which we could prevent per confirmation box. This boy would be annoying for many and requires a "[ ] Don't show again".
Suggest to resolve the ticket as WFM.
Comment 4 Mike Kaganski 2020-06-04 14:18:43 UTC
It's strong WF. If you consider styles separate from document content, you are mistaken, and if a document change is not included in undo/redo, then the whole undo/redo would stop functioning (i.e., as soon as such a change arrives, all undo history gets cleared, or else the application would likely to get into inconsistent state).